/* gdt.h */

/* define gdt structure */
typedef struct _gdt_entry {
	unsigned short limit_low;
	unsigned short base_low;
	unsigned char  base_middle;
	unsigned char  access;
	unsigned char  granularity;
	unsigned char  base_high;
} __attribute__ ((__packed__)) gdt_entry;

/* pointer structure to gdt */
typedef struct _gdt_ptr {
	unsigned short limit;
	unsigned int  base;
} __attribute__ ((__packed__)) gdt_ptr;

/* gdt_flush is in start.asm */
extern void gdt_flush();

/* function prototypes */
void gdt_set_gate(int num, unsigned long base, unsigned long limit,
		  unsigned char access, unsigned char gran);

void gdt_install();

/* end gdt.h */
