/* idt.h */

#ifndef __IDT_H
#define __IDT_H

/* defined idt entry */
typedef struct _idt_entry {
	unsigned short base_low;  /* offset bits 0-15 */
	unsigned short selector;  /* code segment selector in gdt or ldt */
	unsigned char  zero;	  /* unused - always 0 */
	unsigned char  flags;	  /* type and attributes */
	unsigned short base_high; /* offset bits 16-31 */
} __attribute__ ((__packed__)) idt_entry;

/* define idt pointer */
typedef struct _idt_ptr {
	unsigned short limit;
	unsigned int   base;
} __attribute__ ((__packed__)) idt_ptr;

idt_entry idt[256];
idt_ptr   idtp;

/* idt_load is in start.asm */
extern void idt_load();

/* function prototypes */
void idt_set_gate(unsigned char num, unsigned long base,
		  unsigned short sel, unsigned char flags);
void idt_install();

#endif

/* end idt.h */
