/* screen.h */

#ifndef __SCREEN_H
#define __SCREEN_H

/* define reasonable screen geometry limits */
#define TEXT_SCREEN_MAX_Y 25
#define TEXT_SCREEN_MAX_X 80

/* define sensible character mappings */
#define CHAR_BLANK 0x20

/* vga controller data */
#define CRTC_INDEX 0x3D4	/* crt controller index */
#define CRTC_DATA  0x3D5	/* crt controller data  */

/* define colors */
#define BLACK         0x0
#define BLUE          0x1
#define GREEN         0x2
#define CYAN          0x3
#define RED           0x4
#define MAGENTA       0x5
#define BROWN         0x6
#define LIGHT_GRAY    0x7
#define DARK_GRAY     0x8
#define LIGHT_BLUE    0x9
#define LIGHT_GREEN   0xA
#define LIGHT_CYAN    0xB
#define LIGHT_RED     0xC
#define LIGHT_MAGENTA 0xD
#define YELLOW        0xE
#define WHITE         0xF

/* structure to hold text cursor x,y coordinates */
typedef struct _text_cursor {
	int x;
	int y;
} text_cursor;

void scroll();
void move_cursor();
void cls();
void set_text_color(unsigned char f, unsigned char b);
void init_video();

#endif

/* end screen.h */
