/* string.c */

#include <string.h>
#include <screen.h>

extern unsigned short *textmemptr;
extern text_cursor cursor;
extern int attrib;

int strlen(const unsigned char *str)
{
	int retval;

	for (retval = 0; *str != '\0'; str++)
		retval++;

	return retval;
} /* strlen() */

/* put a character on screen */
void putch(unsigned char c)
{
        unsigned short *where;
        unsigned att = attrib << 8;

        if (c == 0x08)          /* backspace */
        {
                if (cursor.x != 0)
                        cursor.x--;
        }
        else if (c == 0x09)     /* tab - divisible by 8 */
        {
                cursor.x = (cursor.x + 8) & ~(8 - 1);
        }
        else if (c == '\r')     /* carriage return */
        {
                cursor.x = 0;
        }
        else if (c == '\n')     /* newline */
        {
                cursor.x = 0;
                cursor.y++;
        }
        else if (c >= ' ')      /* any other printable characters */
        {
                where = textmemptr + (cursor.y * TEXT_SCREEN_MAX_X + cursor.x);
                *where = c | att; /* character and attributes */
                cursor.x++;
        }

        if (cursor.x >= TEXT_SCREEN_MAX_X) /* text for right margin */
        {
                cursor.x = 0;
                cursor.y++;
        }

        /* finally, scroll screen and move hardware cursor */
        scroll();
        move_cursor();
} /* putch() */

/* use putch() to output strings */
void puts(unsigned char *text)
{
        int i;

        for (i = 0; i < strlen(text); i++)
                putch(text[i]);
} /* puts() */

/* end string.c */
