/* system.c */

#include <system.h>

/* copy region of memory to another */
unsigned char *memcpy(unsigned char *dest, const unsigned char *src, int count)
{
	const char *sp = (const char *)src;
	char *dp = (char *)dest;

	for ( ; count != 0; count--)
		*dp++ = *sp++;

	return dest;
}	/* memcpy() */

/* set region of memory with value */
unsigned char *memset(unsigned char *dest, const unsigned char val, int count)
{
	char *temp = (char *)dest;

	for ( ; count != 0; count --)
		*temp++ = val;

	return dest;
}	/* memset() */


/* set region of memory with 16-bit value */
unsigned short *memsetw(unsigned short *dest, unsigned short val, int count)
{
	unsigned short *temp = (unsigned short *)dest;

	for ( ; count != 0; count--)
		*temp++ = val;

	return dest;
}	/* memsetw() */
	

/* read from i/o ports */
unsigned char inportb(unsigned short _port)
{
	unsigned char rv;

	__asm__ __volatile__("inb %1, %0" : "=a" (rv) : "dN" (_port));
	return rv;
} /* inportb() */


/* write to i/o ports to send bytes to devices */
void outportb(unsigned short _port, unsigned char _data)
{
	__asm__ __volatile__("outb %1, %0" : : "dN" (_port), "a" (_data));
} /* outportb() */

/* end system.c */
